/*
 * interface dependent routings, basically called thru jump table
 * (DLT type).  if_ether is for ethernet.
 * user - is string passed from main level thru pcap loop routine.
 * h - pcap header structure
 * p - the packet itself
 *	Sub-variables:
 *	length - length of the packet
 *	caplen - bytes actually captured.
 */
void
if_ether(user, h, p)
	char *user;
	struct pcap_pkthdr *h;
	u_char *p;
{
	extern int debug;
	struct t_entry *te = NULL;

	u_int caplen = h->caplen;	/* amt. actually captured */
	u_int length = h->len;		/* length of packet */

#ifdef MDEBUG
	if (debug) {
		printf("if_ether: caplen %d, length %d, p %x\n", caplen, length, p);
	}
#endif

	if (caplen < ETHER_HDRLEN) 
		return;

	/* snapend is pointer to end of packet buffer
	*/
	snapend = p + caplen;

	/* if 802.1Q we must adjust the packet.
	 */
	if ( ntohs(((struct ether_header *)p)->ether_type) == 0x8100) {
		char buf[12];
		
		memcpy(buf, p, 12);
		p += 4;
		memcpy(p, buf, 12);	/* overwrite the 4 bytes of vlan tag */
		caplen -= 4;
		length -= 4;
		h->caplen -= 4;
		h->len -= 4;
		if (debug) {
			printf("xyz802.1Q packet, type is %x\n",  
				ntohs(((struct ether_header *)p)->ether_type)); 
		}
	}
	else {
#ifdef MDEBUG
		if (debug) {
			printf("xyz not 802.1Q packet, type is %x\n", 
				ntohs(((struct ether_header *)p)->ether_type)); 
		}
#endif
	}

	if ( ntohs(((struct ether_header *)p)->ether_type) == ETHERTYPE_IP) {
		te = analyze_ip(p + ETHER_HDRLEN, length - ETHER_HDRLEN, length,
			(struct ether_header *)p);
	}
#ifdef MDEBUG
	else {
		if (debug) {
			printf("xyz not IP packet, type is %x\n", ntohs(((struct ether_header *)p)->ether_type)); 
		}
	}
#endif

	/* ethernet header still intact 
	*/
	if (any_bpf) {
		analyze_bpf(h, p, caplen, length, te);
	}
	
	if (trigger_worm_state != 0)  {	
		trigger_work(h, p, caplen, length); 
	}
}
